// swift-tools-version:5.3
// The swift-tools-version declares the minimum version of Swift required to build this package.

import PackageDescription

let package = Package(
    name: "ResgenSwift",
    platforms: [.macOS(.v10_12)],
    dependencies: [
        // Dependencies declare other packages that this package depends on.
        .package(url: "https://github.com/apple/swift-argument-parser", from: "1.0.0")
    ],
    targets: [
        // Targets are the basic building blocks of a package. A target can define a module or a test suite.
        // Targets can depend on other targets in this package, and on products in packages this package depends on.
        .target(
            name: "ResgenSwift",
            dependencies: ["FontToolCore", "ColorToolCore", "TwineToolCore", "StringToolCore", "Strings"]
        ),
        .target(
            name: "FontToolCore",
            dependencies: [
                "CLIToolCore",
                .product(name: "ArgumentParser", package: "swift-argument-parser")
            ]
        ),
        .target(
            name: "ColorToolCore",
            dependencies: [
                "CLIToolCore",
                .product(name: "ArgumentParser", package: "swift-argument-parser")
            ]
        ),
        .target(
            name: "TwineToolCore",
            dependencies: [
                "CLIToolCore",
                .product(name: "ArgumentParser", package: "swift-argument-parser")
            ]
        ),
        .target(
            name: "StringToolCore",
            dependencies: [
                "CLIToolCore",
                .product(name: "ArgumentParser", package: "swift-argument-parser")
            ]
        ),
        .target(
            name: "Strings",
            dependencies: [
                "CLIToolCore",
                .product(name: "ArgumentParser", package: "swift-argument-parser")
            ]
        ),
        // Helper targets
        .target(name: "CLIToolCore"),
        // Test targets
        .testTarget(
            name: "ResgenSwiftTests",
            dependencies: ["ResgenSwift"]),
    ]
)
